拓扑排序入门-D-HDU-3342Legal or Not (拓扑排序判环模板)

Legal or Not 

ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.

Input

The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0. 
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.

Output

For each test case, print in one line the judgement of the messy relationship. 
If it is legal, output "YES", otherwise "NO".

Sample Input

3 2
0 1
1 2
2 2
0 1
1 0
0 0

Sample Output

YES
NO

裸得不能再裸的模板题

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include<cstdio>
#include <cstring>
#include <queue>
#include <map>
#include <string.h>
#include<bitset>
typedef long long ll;

using namespace std;
const int   inf=0x3f3f3f3f;
//int inf  = 2e7+100;

vector<int > v[11111],l[11111];
vector<int> ans;
map<string ,int > mp,vism;
map<int ,string>mp2;
map<string,map<string ,int > >in;

int n,m,s,num;
int   G[2222][2222];
int   vis[11111],d[1111],p[1111];

long long int topo()
{
    int cnt=0;
    queue<int> q;
    for(int i=0;i<n;i++)
    {
        if(vis[i]==0)
           {
               q.push(i);
               cnt++;
           }
    }

    while(!q.empty())
    {

        int t=q.front();
        q.pop();
        for(int i=0;i<v[t].size();i++)
        {
            int k=v[t][i];
            vis[k]--;
            if(vis[k]==0)
            {
                q.push(k);
                 cnt++;

            }
        }

    }
    if(cnt==n)
        return 1;
    else
        return 0;
}


int main()
{

   while(scanf("%d%d",&n,&m)!=EOF)
   {
       if(n==0&&m==0)
         break;
       for(int i=0;i<=n;i++)
         v[i].clear();
       memset(vis,0,sizeof(vis));
       for(int i=1;i<=m;i++)
       {
           int a,b;
           scanf("%d%d",&a,&b);
           v[a].push_back(b);
           vis[b]++;
       }
       int ans=topo();
       if(ans)
         cout<<"YES"<<endl;
       else
         cout<<"NO"<<endl;
   }
    return 0;
}
扫描二维码关注公众号,回复: 6794226 查看本文章

猜你喜欢

转载自blog.csdn.net/qq_43256272/article/details/95317279